#include "tddFuncs.h"

#include <iostream>

// if c is a letter, return it as uppercase
char ToUpper(char c) {
  if ('a' <= c && c <= ('z' + 1)) {
    return c - 'a' + 'A';
  }
  return c;
}

// class Statistics {
// public:
//   Statistics(DataSource& source);
// private:
//   DataSource source;
// };

// class MaxLast10 : public Statistics { ... };

// class DataSource {
// public:
//   float NextValue();
// };

// class FileSource : public DataSource { ... };
// class NetworkSource : public DataSource { ... };

// class MockSource : public DataSource {
// public:
//   MockSource(vector<float>& mockData) : current(mockData.begin());
//   float NextValue() {
//     return *current++;
//   }
// private:
//   vector<float>::iterator current;
// };

// MaxLast10 maxLast10(MockSource({1,20,1,-3,...}));
// ASSERT_EQUALS(maxLast10.foo(), ..);

// return value >= 0
float DistanceSquared(float x1, float x2, float y1, float y2) {
  float x = x1 - x2;
  float y = y1 - y2;
  return x * x + y * y;
}

int ReLU(int input, int weight) {
  if (input <= 0) {
    return 0;
  }
  return input * weight;
}

int main(int argc, char *argv[]) {
  ASSERT_EQUALS(ToUpper('a'), 'A');
  ASSERT_EQUALS(ToUpper('z'), 'Z');
  ASSERT_EQUALS(ToUpper('A'), 'A');
  ASSERT_EQUALS(ToUpper('Z'), 'Z');
  ASSERT_EQUALS(ToUpper('4'), '4');
  // ASSERT_EQUALS(8.0f, (DistanceSquared(3, 5, 5, 7)));
  return 0;
}

// SQLite

// open, close, ...
// file system tree
// block allocation
// disk I/O
